require 'minitest_helper'

describe RegexpScan::Scanner do
  describe '#initialize' do
    describe 'initialize by String' do
      before do
        @scanner = RegexpScan::Scanner.new('\d+')
      end

      it 'filtering only match string' do
        assert @scanner.execute('1111,2222,') == ['1111', '2222']
      end
    end

    describe 'initialize by Regexp' do
      before do
        @scanner = RegexpScan::Scanner.new(/\d+/)
      end

      it 'filtering only match string' do
        assert @scanner.execute('1111,2222,') == ['1111', '2222']
      end
    end

    describe 'initilaize by not Regxp and not String' do
      it 'raise' do
        assert_raises(ArgumentError){ RegexpScan::Scanner.new(111122223333) }
      end
    end
  end

  describe '#execute' do
    describe 'string. that include match string' do
      before do
        @scanner = RegexpScan::Scanner.new('\d+')
      end

      it 'array of match string' do
        assert @scanner.execute('1111,2222,3333') == ['1111', '2222', '3333']
      end
    end

    describe 'string. that does not include match string' do
      before do
        @scanner = RegexpScan::Scanner.new('\d+')
      end

      it 'empty array' do
        assert @scanner.execute('aaaa,bbbb,cccc').empty?
      end
    end
  end
end